#ifndef PAM_FINGERPRINT_H_
#define PAM_FINGERPRINT_H_

#ifndef _GNU_SOURCE
# define _GNU_SOURCE 1
#endif

#ifndef UNUSED
#define UNUSED __attribute__ ((unused))
#endif

#define _pam_overwrite(x)        \
do {                             \
     register char *__xx__;      \
     if ((__xx__=(x)))           \
          while (*__xx__)        \
               *__xx__++ = '\0'; \
} while (0)

#define _pam_overwrite_n(x,n)   \
do {                             \
     register char *__xx__;      \
     register unsigned int __i__ = 0;    \
     if ((__xx__=(x)))           \
        for (;__i__<n; __i__++) \
            __xx__[__i__] = 0; \
} while (0)

/*
 * Don't just free it, forget it too.
 */

#define _pam_drop(X) \
do {                 \
    if (X) {         \
        free(X);     \
        X=NULL;      \
    }                \
} while (0)

#define _pam_delete(xx)		\
{				\
	_pam_overwrite(xx);	\
	_pam_drop(xx);		\
}

/* pam_prompt (pam_handle_t *pamh, int style, char **response,
	    const char *fmt, ...); */

#endif // PAM_FINGERPRINT_H_